/*******************************************************************************
 * Copyright (c) 2014 Bosch Software Innovations GmbH and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v1.0 which accompany this distribution.
 *
 * The Eclipse Public License is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * The Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 * Bosch Software Innovations GmbH - Please refer to git log
 *
 *******************************************************************************/
/*
 * generated by Xtext
 */
grammar InternalDatatype;

options {
	superClass=AbstractInternalContentAssistParser;
}

@lexer::header {
package org.eclipse.vorto.editor.datatype.ide.contentassist.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.Lexer;
}

@parser::header {
package org.eclipse.vorto.editor.datatype.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.vorto.editor.datatype.services.DatatypeGrammarAccess;

}
@parser::members {
	private DatatypeGrammarAccess grammarAccess;

	public void setGrammarAccess(DatatypeGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}

	@Override
	protected Grammar getGrammar() {
		return grammarAccess.getGrammar();
	}

	@Override
	protected String getValueForTokenName(String tokenName) {
		return tokenName;
	}
}

// Entry rule entryRuleModel
entryRuleModel
:
{ before(grammarAccess.getModelRule()); }
	 ruleModel
{ after(grammarAccess.getModelRule()); } 
	 EOF 
;

// Rule Model
ruleModel 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getModelAccess().getTypeParserRuleCall()); }
		ruleType
		{ after(grammarAccess.getModelAccess().getTypeParserRuleCall()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleModelReference
entryRuleModelReference
:
{ before(grammarAccess.getModelReferenceRule()); }
	 ruleModelReference
{ after(grammarAccess.getModelReferenceRule()); } 
	 EOF 
;

// Rule ModelReference
ruleModelReference 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getModelReferenceAccess().getGroup()); }
		(rule__ModelReference__Group__0)
		{ after(grammarAccess.getModelReferenceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleQualifiedName
entryRuleQualifiedName
:
{ before(grammarAccess.getQualifiedNameRule()); }
	 ruleQualifiedName
{ after(grammarAccess.getQualifiedNameRule()); } 
	 EOF 
;

// Rule QualifiedName
ruleQualifiedName 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getQualifiedNameAccess().getGroup()); }
		(rule__QualifiedName__Group__0)
		{ after(grammarAccess.getQualifiedNameAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleType
entryRuleType
:
{ before(grammarAccess.getTypeRule()); }
	 ruleType
{ after(grammarAccess.getTypeRule()); } 
	 EOF 
;

// Rule Type
ruleType 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getTypeAccess().getAlternatives()); }
		(rule__Type__Alternatives)
		{ after(grammarAccess.getTypeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEntity
entryRuleEntity
:
{ before(grammarAccess.getEntityRule()); }
	 ruleEntity
{ after(grammarAccess.getEntityRule()); } 
	 EOF 
;

// Rule Entity
ruleEntity 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEntityAccess().getGroup()); }
		(rule__Entity__Group__0)
		{ after(grammarAccess.getEntityAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnum
entryRuleEnum
:
{ before(grammarAccess.getEnumRule()); }
	 ruleEnum
{ after(grammarAccess.getEnumRule()); } 
	 EOF 
;

// Rule Enum
ruleEnum 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumAccess().getGroup()); }
		(rule__Enum__Group__0)
		{ after(grammarAccess.getEnumAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumLiteral
entryRuleEnumLiteral
:
{ before(grammarAccess.getEnumLiteralRule()); }
	 ruleEnumLiteral
{ after(grammarAccess.getEnumLiteralRule()); } 
	 EOF 
;

// Rule EnumLiteral
ruleEnumLiteral 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumLiteralAccess().getGroup()); }
		(rule__EnumLiteral__Group__0)
		{ after(grammarAccess.getEnumLiteralAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleProperty
entryRuleProperty
:
{ before(grammarAccess.getPropertyRule()); }
	 ruleProperty
{ after(grammarAccess.getPropertyRule()); } 
	 EOF 
;

// Rule Property
ruleProperty 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPropertyAccess().getGroup()); }
		(rule__Property__Group__0)
		{ after(grammarAccess.getPropertyAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleConstraintRule
entryRuleConstraintRule
:
{ before(grammarAccess.getConstraintRuleRule()); }
	 ruleConstraintRule
{ after(grammarAccess.getConstraintRuleRule()); } 
	 EOF 
;

// Rule ConstraintRule
ruleConstraintRule 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getConstraintRuleAccess().getGroup()); }
		(rule__ConstraintRule__Group__0)
		{ after(grammarAccess.getConstraintRuleAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumLiteralName
entryRuleEnumLiteralName
:
{ before(grammarAccess.getEnumLiteralNameRule()); }
	 ruleEnumLiteralName
{ after(grammarAccess.getEnumLiteralNameRule()); } 
	 EOF 
;

// Rule EnumLiteralName
ruleEnumLiteralName 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumLiteralNameAccess().getGroup()); }
		(rule__EnumLiteralName__Group__0)
		{ after(grammarAccess.getEnumLiteralNameAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePropertyAttribute
entryRulePropertyAttribute
:
{ before(grammarAccess.getPropertyAttributeRule()); }
	 rulePropertyAttribute
{ after(grammarAccess.getPropertyAttributeRule()); } 
	 EOF 
;

// Rule PropertyAttribute
rulePropertyAttribute 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPropertyAttributeAccess().getAlternatives()); }
		(rule__PropertyAttribute__Alternatives)
		{ after(grammarAccess.getPropertyAttributeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleBooleanPropertyAttribute
entryRuleBooleanPropertyAttribute
:
{ before(grammarAccess.getBooleanPropertyAttributeRule()); }
	 ruleBooleanPropertyAttribute
{ after(grammarAccess.getBooleanPropertyAttributeRule()); } 
	 EOF 
;

// Rule BooleanPropertyAttribute
ruleBooleanPropertyAttribute 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getBooleanPropertyAttributeAccess().getGroup()); }
		(rule__BooleanPropertyAttribute__Group__0)
		{ after(grammarAccess.getBooleanPropertyAttributeAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumLiteralPropertyAttribute
entryRuleEnumLiteralPropertyAttribute
:
{ before(grammarAccess.getEnumLiteralPropertyAttributeRule()); }
	 ruleEnumLiteralPropertyAttribute
{ after(grammarAccess.getEnumLiteralPropertyAttributeRule()); } 
	 EOF 
;

// Rule EnumLiteralPropertyAttribute
ruleEnumLiteralPropertyAttribute 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumLiteralPropertyAttributeAccess().getGroup()); }
		(rule__EnumLiteralPropertyAttribute__Group__0)
		{ after(grammarAccess.getEnumLiteralPropertyAttributeAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePropertyType
entryRulePropertyType
:
{ before(grammarAccess.getPropertyTypeRule()); }
	 rulePropertyType
{ after(grammarAccess.getPropertyTypeRule()); } 
	 EOF 
;

// Rule PropertyType
rulePropertyType 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPropertyTypeAccess().getAlternatives()); }
		(rule__PropertyType__Alternatives)
		{ after(grammarAccess.getPropertyTypeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePrimitivePropertyType
entryRulePrimitivePropertyType
:
{ before(grammarAccess.getPrimitivePropertyTypeRule()); }
	 rulePrimitivePropertyType
{ after(grammarAccess.getPrimitivePropertyTypeRule()); } 
	 EOF 
;

// Rule PrimitivePropertyType
rulePrimitivePropertyType 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPrimitivePropertyTypeAccess().getTypeAssignment()); }
		(rule__PrimitivePropertyType__TypeAssignment)
		{ after(grammarAccess.getPrimitivePropertyTypeAccess().getTypeAssignment()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleObjectPropertyType
entryRuleObjectPropertyType
:
{ before(grammarAccess.getObjectPropertyTypeRule()); }
	 ruleObjectPropertyType
{ after(grammarAccess.getObjectPropertyTypeRule()); } 
	 EOF 
;

// Rule ObjectPropertyType
ruleObjectPropertyType 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getObjectPropertyTypeAccess().getTypeAssignment()); }
		(rule__ObjectPropertyType__TypeAssignment)
		{ after(grammarAccess.getObjectPropertyTypeAccess().getTypeAssignment()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleComplexPrimitivePropertyType
entryRuleComplexPrimitivePropertyType
:
{ before(grammarAccess.getComplexPrimitivePropertyTypeRule()); }
	 ruleComplexPrimitivePropertyType
{ after(grammarAccess.getComplexPrimitivePropertyTypeRule()); } 
	 EOF 
;

// Rule ComplexPrimitivePropertyType
ruleComplexPrimitivePropertyType 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getComplexPrimitivePropertyTypeAccess().getDictionaryPropertyTypeParserRuleCall()); }
		ruleDictionaryPropertyType
		{ after(grammarAccess.getComplexPrimitivePropertyTypeAccess().getDictionaryPropertyTypeParserRuleCall()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleDictionaryPropertyType
entryRuleDictionaryPropertyType
:
{ before(grammarAccess.getDictionaryPropertyTypeRule()); }
	 ruleDictionaryPropertyType
{ after(grammarAccess.getDictionaryPropertyTypeRule()); } 
	 EOF 
;

// Rule DictionaryPropertyType
ruleDictionaryPropertyType 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getDictionaryPropertyTypeAccess().getGroup()); }
		(rule__DictionaryPropertyType__Group__0)
		{ after(grammarAccess.getDictionaryPropertyTypeAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePresence
entryRulePresence
:
{ before(grammarAccess.getPresenceRule()); }
	 rulePresence
{ after(grammarAccess.getPresenceRule()); } 
	 EOF 
;

// Rule Presence
rulePresence 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPresenceAccess().getGroup()); }
		(rule__Presence__Group__0)
		{ after(grammarAccess.getPresenceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleConstraint
entryRuleConstraint
:
{ before(grammarAccess.getConstraintRule()); }
	 ruleConstraint
{ after(grammarAccess.getConstraintRule()); } 
	 EOF 
;

// Rule Constraint
ruleConstraint 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getConstraintAccess().getGroup()); }
		(rule__Constraint__Group__0)
		{ after(grammarAccess.getConstraintAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleIntervalType
entryRuleIntervalType
:
{ before(grammarAccess.getIntervalTypeRule()); }
	 ruleIntervalType
{ after(grammarAccess.getIntervalTypeRule()); } 
	 EOF 
;

// Rule IntervalType
ruleIntervalType 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getIntervalTypeAccess().getAlternatives()); }
		(rule__IntervalType__Alternatives)
		{ after(grammarAccess.getIntervalTypeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleCATEGORY
entryRuleCATEGORY
:
{ before(grammarAccess.getCATEGORYRule()); }
	 ruleCATEGORY
{ after(grammarAccess.getCATEGORYRule()); } 
	 EOF 
;

// Rule CATEGORY
ruleCATEGORY 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getCATEGORYAccess().getGroup()); }
		(rule__CATEGORY__Group__0)
		{ after(grammarAccess.getCATEGORYAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Rule BooleanPropertyAttributeType
ruleBooleanPropertyAttributeType
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getBooleanPropertyAttributeTypeAccess().getAlternatives()); }
		(rule__BooleanPropertyAttributeType__Alternatives)
		{ after(grammarAccess.getBooleanPropertyAttributeTypeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Rule EnumLiteralPropertyAttributeType
ruleEnumLiteralPropertyAttributeType
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumLiteralPropertyAttributeTypeAccess().getMeasurementUnitEnumLiteralDeclaration()); }
		('measurementUnit')
		{ after(grammarAccess.getEnumLiteralPropertyAttributeTypeAccess().getMeasurementUnitEnumLiteralDeclaration()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Rule PrimitiveType
rulePrimitiveType
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getAlternatives()); }
		(rule__PrimitiveType__Alternatives)
		{ after(grammarAccess.getPrimitiveTypeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Rule ConstraintIntervalType
ruleConstraintIntervalType
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getConstraintIntervalTypeAccess().getAlternatives()); }
		(rule__ConstraintIntervalType__Alternatives)
		{ after(grammarAccess.getConstraintIntervalTypeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Type__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTypeAccess().getEntityParserRuleCall_0()); }
		ruleEntity
		{ after(grammarAccess.getTypeAccess().getEntityParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getTypeAccess().getEnumParserRuleCall_1()); }
		ruleEnum
		{ after(grammarAccess.getTypeAccess().getEnumParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PropertyAttribute__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAttributeAccess().getBooleanPropertyAttributeParserRuleCall_0()); }
		ruleBooleanPropertyAttribute
		{ after(grammarAccess.getPropertyAttributeAccess().getBooleanPropertyAttributeParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getPropertyAttributeAccess().getEnumLiteralPropertyAttributeParserRuleCall_1()); }
		ruleEnumLiteralPropertyAttribute
		{ after(grammarAccess.getPropertyAttributeAccess().getEnumLiteralPropertyAttributeParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttribute__Alternatives_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getBooleanPropertyAttributeAccess().getValueAssignment_2_0()); }
		(rule__BooleanPropertyAttribute__ValueAssignment_2_0)
		{ after(grammarAccess.getBooleanPropertyAttributeAccess().getValueAssignment_2_0()); }
	)
	|
	(
		{ before(grammarAccess.getBooleanPropertyAttributeAccess().getFalseKeyword_2_1()); }
		'false'
		{ after(grammarAccess.getBooleanPropertyAttributeAccess().getFalseKeyword_2_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PropertyType__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyTypeAccess().getObjectPropertyTypeParserRuleCall_0()); }
		ruleObjectPropertyType
		{ after(grammarAccess.getPropertyTypeAccess().getObjectPropertyTypeParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getPropertyTypeAccess().getPrimitivePropertyTypeParserRuleCall_1()); }
		rulePrimitivePropertyType
		{ after(grammarAccess.getPropertyTypeAccess().getPrimitivePropertyTypeParserRuleCall_1()); }
	)
	|
	(
		{ before(grammarAccess.getPropertyTypeAccess().getComplexPrimitivePropertyTypeParserRuleCall_2()); }
		ruleComplexPrimitivePropertyType
		{ after(grammarAccess.getPropertyTypeAccess().getComplexPrimitivePropertyTypeParserRuleCall_2()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Presence__Alternatives_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPresenceAccess().getMandatoryAssignment_1_0()); }
		(rule__Presence__MandatoryAssignment_1_0)
		{ after(grammarAccess.getPresenceAccess().getMandatoryAssignment_1_0()); }
	)
	|
	(
		{ before(grammarAccess.getPresenceAccess().getOptionalKeyword_1_1()); }
		'optional'
		{ after(grammarAccess.getPresenceAccess().getOptionalKeyword_1_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__IntervalType__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getIntervalTypeAccess().getINTTerminalRuleCall_0()); }
		RULE_INT
		{ after(grammarAccess.getIntervalTypeAccess().getINTTerminalRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getIntervalTypeAccess().getSIGNEDINTTerminalRuleCall_1()); }
		RULE_SIGNEDINT
		{ after(grammarAccess.getIntervalTypeAccess().getSIGNEDINTTerminalRuleCall_1()); }
	)
	|
	(
		{ before(grammarAccess.getIntervalTypeAccess().getFLOATTerminalRuleCall_2()); }
		RULE_FLOAT
		{ after(grammarAccess.getIntervalTypeAccess().getFLOATTerminalRuleCall_2()); }
	)
	|
	(
		{ before(grammarAccess.getIntervalTypeAccess().getDATETIMETerminalRuleCall_3()); }
		RULE_DATETIME
		{ after(grammarAccess.getIntervalTypeAccess().getDATETIMETerminalRuleCall_3()); }
	)
	|
	(
		{ before(grammarAccess.getIntervalTypeAccess().getSTRINGTerminalRuleCall_4()); }
		RULE_STRING
		{ after(grammarAccess.getIntervalTypeAccess().getSTRINGTerminalRuleCall_4()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttributeType__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getBooleanPropertyAttributeTypeAccess().getReadableEnumLiteralDeclaration_0()); }
		('readable')
		{ after(grammarAccess.getBooleanPropertyAttributeTypeAccess().getReadableEnumLiteralDeclaration_0()); }
	)
	|
	(
		{ before(grammarAccess.getBooleanPropertyAttributeTypeAccess().getWritableEnumLiteralDeclaration_1()); }
		('writable')
		{ after(grammarAccess.getBooleanPropertyAttributeTypeAccess().getWritableEnumLiteralDeclaration_1()); }
	)
	|
	(
		{ before(grammarAccess.getBooleanPropertyAttributeTypeAccess().getEventableEnumLiteralDeclaration_2()); }
		('eventable')
		{ after(grammarAccess.getBooleanPropertyAttributeTypeAccess().getEventableEnumLiteralDeclaration_2()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PrimitiveType__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getStringEnumLiteralDeclaration_0()); }
		('string')
		{ after(grammarAccess.getPrimitiveTypeAccess().getStringEnumLiteralDeclaration_0()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getIntEnumLiteralDeclaration_1()); }
		('int')
		{ after(grammarAccess.getPrimitiveTypeAccess().getIntEnumLiteralDeclaration_1()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getFloatEnumLiteralDeclaration_2()); }
		('float')
		{ after(grammarAccess.getPrimitiveTypeAccess().getFloatEnumLiteralDeclaration_2()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getBooleanEnumLiteralDeclaration_3()); }
		('boolean')
		{ after(grammarAccess.getPrimitiveTypeAccess().getBooleanEnumLiteralDeclaration_3()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getDatetimeEnumLiteralDeclaration_4()); }
		('dateTime')
		{ after(grammarAccess.getPrimitiveTypeAccess().getDatetimeEnumLiteralDeclaration_4()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getDoubleEnumLiteralDeclaration_5()); }
		('double')
		{ after(grammarAccess.getPrimitiveTypeAccess().getDoubleEnumLiteralDeclaration_5()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getLongEnumLiteralDeclaration_6()); }
		('long')
		{ after(grammarAccess.getPrimitiveTypeAccess().getLongEnumLiteralDeclaration_6()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getShortEnumLiteralDeclaration_7()); }
		('short')
		{ after(grammarAccess.getPrimitiveTypeAccess().getShortEnumLiteralDeclaration_7()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getBase64BinaryEnumLiteralDeclaration_8()); }
		('base64Binary')
		{ after(grammarAccess.getPrimitiveTypeAccess().getBase64BinaryEnumLiteralDeclaration_8()); }
	)
	|
	(
		{ before(grammarAccess.getPrimitiveTypeAccess().getByteEnumLiteralDeclaration_9()); }
		('byte')
		{ after(grammarAccess.getPrimitiveTypeAccess().getByteEnumLiteralDeclaration_9()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintIntervalType__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getConstraintIntervalTypeAccess().getMinEnumLiteralDeclaration_0()); }
		('MIN')
		{ after(grammarAccess.getConstraintIntervalTypeAccess().getMinEnumLiteralDeclaration_0()); }
	)
	|
	(
		{ before(grammarAccess.getConstraintIntervalTypeAccess().getMaxEnumLiteralDeclaration_1()); }
		('MAX')
		{ after(grammarAccess.getConstraintIntervalTypeAccess().getMaxEnumLiteralDeclaration_1()); }
	)
	|
	(
		{ before(grammarAccess.getConstraintIntervalTypeAccess().getStrlenEnumLiteralDeclaration_2()); }
		('STRLEN')
		{ after(grammarAccess.getConstraintIntervalTypeAccess().getStrlenEnumLiteralDeclaration_2()); }
	)
	|
	(
		{ before(grammarAccess.getConstraintIntervalTypeAccess().getRegexEnumLiteralDeclaration_3()); }
		('REGEX')
		{ after(grammarAccess.getConstraintIntervalTypeAccess().getRegexEnumLiteralDeclaration_3()); }
	)
	|
	(
		{ before(grammarAccess.getConstraintIntervalTypeAccess().getMimetypeEnumLiteralDeclaration_4()); }
		('MIMETYPE')
		{ after(grammarAccess.getConstraintIntervalTypeAccess().getMimetypeEnumLiteralDeclaration_4()); }
	)
	|
	(
		{ before(grammarAccess.getConstraintIntervalTypeAccess().getScalingEnumLiteralDeclaration_5()); }
		('SCALING')
		{ after(grammarAccess.getConstraintIntervalTypeAccess().getScalingEnumLiteralDeclaration_5()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__0__Impl
	rule__ModelReference__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getUsingKeyword_0()); }
	'using'
	{ after(grammarAccess.getModelReferenceAccess().getUsingKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__1__Impl
	rule__ModelReference__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getImportedNamespaceAssignment_1()); }
	(rule__ModelReference__ImportedNamespaceAssignment_1)
	{ after(grammarAccess.getModelReferenceAccess().getImportedNamespaceAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__2__Impl
	rule__ModelReference__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getSemicolonKeyword_2()); }
	';'
	{ after(grammarAccess.getModelReferenceAccess().getSemicolonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getVersionAssignment_3()); }
	(rule__ModelReference__VersionAssignment_3)
	{ after(grammarAccess.getModelReferenceAccess().getVersionAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__QualifiedName__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group__0__Impl
	rule__QualifiedName__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); }
	RULE_ID
	{ after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getGroup_1()); }
	(rule__QualifiedName__Group_1__0)*
	{ after(grammarAccess.getQualifiedNameAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__QualifiedName__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group_1__0__Impl
	rule__QualifiedName__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); }
	RULE_ID
	{ after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Entity__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__0__Impl
	rule__Entity__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getNamespaceKeyword_0()); }
	'namespace'
	{ after(grammarAccess.getEntityAccess().getNamespaceKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__1__Impl
	rule__Entity__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getNamespaceAssignment_1()); }
	(rule__Entity__NamespaceAssignment_1)
	{ after(grammarAccess.getEntityAccess().getNamespaceAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__2__Impl
	rule__Entity__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getVersionKeyword_2()); }
	'version'
	{ after(grammarAccess.getEntityAccess().getVersionKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__3__Impl
	rule__Entity__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getVersionAssignment_3()); }
	(rule__Entity__VersionAssignment_3)
	{ after(grammarAccess.getEntityAccess().getVersionAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__4__Impl
	rule__Entity__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getGroup_4()); }
	(rule__Entity__Group_4__0)?
	{ after(grammarAccess.getEntityAccess().getGroup_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__5__Impl
	rule__Entity__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getGroup_5()); }
	(rule__Entity__Group_5__0)?
	{ after(grammarAccess.getEntityAccess().getGroup_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__6__Impl
	rule__Entity__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getGroup_6()); }
	(rule__Entity__Group_6__0)?
	{ after(grammarAccess.getEntityAccess().getGroup_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__7__Impl
	rule__Entity__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getReferencesAssignment_7()); }
	(rule__Entity__ReferencesAssignment_7)*
	{ after(grammarAccess.getEntityAccess().getReferencesAssignment_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__8__Impl
	rule__Entity__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getEntityKeyword_8()); }
	'entity'
	{ after(grammarAccess.getEntityAccess().getEntityKeyword_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__9__Impl
	rule__Entity__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getNameAssignment_9()); }
	(rule__Entity__NameAssignment_9)
	{ after(grammarAccess.getEntityAccess().getNameAssignment_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__10__Impl
	rule__Entity__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getGroup_10()); }
	(rule__Entity__Group_10__0)?
	{ after(grammarAccess.getEntityAccess().getGroup_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__11__Impl
	rule__Entity__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getLeftCurlyBracketKeyword_11()); }
	'{'
	{ after(grammarAccess.getEntityAccess().getLeftCurlyBracketKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__12__Impl
	rule__Entity__Group__13
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getPropertiesAssignment_12()); }
	(rule__Entity__PropertiesAssignment_12)*
	{ after(grammarAccess.getEntityAccess().getPropertiesAssignment_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__13
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group__13__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group__13__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getRightCurlyBracketKeyword_13()); }
	'}'
	{ after(grammarAccess.getEntityAccess().getRightCurlyBracketKeyword_13()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Entity__Group_4__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group_4__0__Impl
	rule__Entity__Group_4__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_4__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getDisplaynameKeyword_4_0()); }
	'displayname'
	{ after(grammarAccess.getEntityAccess().getDisplaynameKeyword_4_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_4__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group_4__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_4__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getDisplaynameAssignment_4_1()); }
	(rule__Entity__DisplaynameAssignment_4_1)
	{ after(grammarAccess.getEntityAccess().getDisplaynameAssignment_4_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Entity__Group_5__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group_5__0__Impl
	rule__Entity__Group_5__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_5__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getDescriptionKeyword_5_0()); }
	'description'
	{ after(grammarAccess.getEntityAccess().getDescriptionKeyword_5_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_5__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group_5__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_5__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getDescriptionAssignment_5_1()); }
	(rule__Entity__DescriptionAssignment_5_1)
	{ after(grammarAccess.getEntityAccess().getDescriptionAssignment_5_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Entity__Group_6__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group_6__0__Impl
	rule__Entity__Group_6__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_6__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getCategoryKeyword_6_0()); }
	'category'
	{ after(grammarAccess.getEntityAccess().getCategoryKeyword_6_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_6__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group_6__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_6__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getCategoryAssignment_6_1()); }
	(rule__Entity__CategoryAssignment_6_1)
	{ after(grammarAccess.getEntityAccess().getCategoryAssignment_6_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Entity__Group_10__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group_10__0__Impl
	rule__Entity__Group_10__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_10__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getExtendsKeyword_10_0()); }
	'extends'
	{ after(grammarAccess.getEntityAccess().getExtendsKeyword_10_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_10__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Entity__Group_10__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__Group_10__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAccess().getSuperTypeAssignment_10_1()); }
	(rule__Entity__SuperTypeAssignment_10_1)
	{ after(grammarAccess.getEntityAccess().getSuperTypeAssignment_10_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Enum__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__0__Impl
	rule__Enum__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getNamespaceKeyword_0()); }
	'namespace'
	{ after(grammarAccess.getEnumAccess().getNamespaceKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__1__Impl
	rule__Enum__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getNamespaceAssignment_1()); }
	(rule__Enum__NamespaceAssignment_1)
	{ after(grammarAccess.getEnumAccess().getNamespaceAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__2__Impl
	rule__Enum__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getVersionKeyword_2()); }
	'version'
	{ after(grammarAccess.getEnumAccess().getVersionKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__3__Impl
	rule__Enum__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getVersionAssignment_3()); }
	(rule__Enum__VersionAssignment_3)
	{ after(grammarAccess.getEnumAccess().getVersionAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__4__Impl
	rule__Enum__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getGroup_4()); }
	(rule__Enum__Group_4__0)?
	{ after(grammarAccess.getEnumAccess().getGroup_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__5__Impl
	rule__Enum__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getGroup_5()); }
	(rule__Enum__Group_5__0)?
	{ after(grammarAccess.getEnumAccess().getGroup_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__6__Impl
	rule__Enum__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getGroup_6()); }
	(rule__Enum__Group_6__0)?
	{ after(grammarAccess.getEnumAccess().getGroup_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__7__Impl
	rule__Enum__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getReferencesAssignment_7()); }
	(rule__Enum__ReferencesAssignment_7)*
	{ after(grammarAccess.getEnumAccess().getReferencesAssignment_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__8__Impl
	rule__Enum__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getEnumKeyword_8()); }
	'enum'
	{ after(grammarAccess.getEnumAccess().getEnumKeyword_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__9__Impl
	rule__Enum__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getNameAssignment_9()); }
	(rule__Enum__NameAssignment_9)
	{ after(grammarAccess.getEnumAccess().getNameAssignment_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__10__Impl
	rule__Enum__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getLeftCurlyBracketKeyword_10()); }
	'{'
	{ after(grammarAccess.getEnumAccess().getLeftCurlyBracketKeyword_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__11__Impl
	rule__Enum__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getGroup_11()); }
	(rule__Enum__Group_11__0)?
	{ after(grammarAccess.getEnumAccess().getGroup_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group__12__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getRightCurlyBracketKeyword_12()); }
	'}'
	{ after(grammarAccess.getEnumAccess().getRightCurlyBracketKeyword_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Enum__Group_4__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_4__0__Impl
	rule__Enum__Group_4__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_4__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getDisplaynameKeyword_4_0()); }
	'displayname'
	{ after(grammarAccess.getEnumAccess().getDisplaynameKeyword_4_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_4__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_4__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_4__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getDisplaynameAssignment_4_1()); }
	(rule__Enum__DisplaynameAssignment_4_1)
	{ after(grammarAccess.getEnumAccess().getDisplaynameAssignment_4_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Enum__Group_5__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_5__0__Impl
	rule__Enum__Group_5__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_5__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getDescriptionKeyword_5_0()); }
	'description'
	{ after(grammarAccess.getEnumAccess().getDescriptionKeyword_5_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_5__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_5__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_5__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getDescriptionAssignment_5_1()); }
	(rule__Enum__DescriptionAssignment_5_1)
	{ after(grammarAccess.getEnumAccess().getDescriptionAssignment_5_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Enum__Group_6__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_6__0__Impl
	rule__Enum__Group_6__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_6__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getCategoryKeyword_6_0()); }
	'category'
	{ after(grammarAccess.getEnumAccess().getCategoryKeyword_6_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_6__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_6__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_6__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getCategoryAssignment_6_1()); }
	(rule__Enum__CategoryAssignment_6_1)
	{ after(grammarAccess.getEnumAccess().getCategoryAssignment_6_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Enum__Group_11__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_11__0__Impl
	rule__Enum__Group_11__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_11__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getEnumsAssignment_11_0()); }
	(rule__Enum__EnumsAssignment_11_0)
	{ after(grammarAccess.getEnumAccess().getEnumsAssignment_11_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_11__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_11__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_11__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getGroup_11_1()); }
	(rule__Enum__Group_11_1__0)*
	{ after(grammarAccess.getEnumAccess().getGroup_11_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Enum__Group_11_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_11_1__0__Impl
	rule__Enum__Group_11_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_11_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getCommaKeyword_11_1_0()); }
	','
	{ after(grammarAccess.getEnumAccess().getCommaKeyword_11_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_11_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Enum__Group_11_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__Group_11_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAccess().getEnumsAssignment_11_1_1()); }
	(rule__Enum__EnumsAssignment_11_1_1)
	{ after(grammarAccess.getEnumAccess().getEnumsAssignment_11_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumLiteral__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumLiteral__Group__0__Impl
	rule__EnumLiteral__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteral__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumLiteralAccess().getNameAssignment_0()); }
	(rule__EnumLiteral__NameAssignment_0)
	{ after(grammarAccess.getEnumLiteralAccess().getNameAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteral__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumLiteral__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteral__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumLiteralAccess().getDescriptionAssignment_1()); }
	(rule__EnumLiteral__DescriptionAssignment_1)?
	{ after(grammarAccess.getEnumLiteralAccess().getDescriptionAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Property__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group__0__Impl
	rule__Property__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getPresenceAssignment_0()); }
	(rule__Property__PresenceAssignment_0)?
	{ after(grammarAccess.getPropertyAccess().getPresenceAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group__1__Impl
	rule__Property__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getMultiplicityAssignment_1()); }
	(rule__Property__MultiplicityAssignment_1)?
	{ after(grammarAccess.getPropertyAccess().getMultiplicityAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group__2__Impl
	rule__Property__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getNameAssignment_2()); }
	(rule__Property__NameAssignment_2)
	{ after(grammarAccess.getPropertyAccess().getNameAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group__3__Impl
	rule__Property__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getAsKeyword_3()); }
	'as'
	{ after(grammarAccess.getPropertyAccess().getAsKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group__4__Impl
	rule__Property__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getTypeAssignment_4()); }
	(rule__Property__TypeAssignment_4)
	{ after(grammarAccess.getPropertyAccess().getTypeAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group__5__Impl
	rule__Property__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getGroup_5()); }
	(rule__Property__Group_5__0)?
	{ after(grammarAccess.getPropertyAccess().getGroup_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group__6__Impl
	rule__Property__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getGroup_6()); }
	(rule__Property__Group_6__0)?
	{ after(grammarAccess.getPropertyAccess().getGroup_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group__7__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getDescriptionAssignment_7()); }
	(rule__Property__DescriptionAssignment_7)?
	{ after(grammarAccess.getPropertyAccess().getDescriptionAssignment_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Property__Group_5__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_5__0__Impl
	rule__Property__Group_5__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getWithKeyword_5_0()); }
	'with'
	{ after(grammarAccess.getPropertyAccess().getWithKeyword_5_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_5__1__Impl
	rule__Property__Group_5__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getLeftCurlyBracketKeyword_5_1()); }
	'{'
	{ after(grammarAccess.getPropertyAccess().getLeftCurlyBracketKeyword_5_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_5__2__Impl
	rule__Property__Group_5__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getPropertyAttributesAssignment_5_2()); }
	(rule__Property__PropertyAttributesAssignment_5_2)
	{ after(grammarAccess.getPropertyAccess().getPropertyAttributesAssignment_5_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_5__3__Impl
	rule__Property__Group_5__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getGroup_5_3()); }
	(rule__Property__Group_5_3__0)*
	{ after(grammarAccess.getPropertyAccess().getGroup_5_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_5__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getRightCurlyBracketKeyword_5_4()); }
	'}'
	{ after(grammarAccess.getPropertyAccess().getRightCurlyBracketKeyword_5_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Property__Group_5_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_5_3__0__Impl
	rule__Property__Group_5_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getCommaKeyword_5_3_0()); }
	','
	{ after(grammarAccess.getPropertyAccess().getCommaKeyword_5_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_5_3__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_5_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getPropertyAttributesAssignment_5_3_1()); }
	(rule__Property__PropertyAttributesAssignment_5_3_1)
	{ after(grammarAccess.getPropertyAccess().getPropertyAttributesAssignment_5_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Property__Group_6__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_6__0__Impl
	rule__Property__Group_6__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_6__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getLessThanSignKeyword_6_0()); }
	'<'
	{ after(grammarAccess.getPropertyAccess().getLessThanSignKeyword_6_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_6__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_6__1__Impl
	rule__Property__Group_6__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_6__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getConstraintRuleAssignment_6_1()); }
	(rule__Property__ConstraintRuleAssignment_6_1)
	{ after(grammarAccess.getPropertyAccess().getConstraintRuleAssignment_6_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_6__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Property__Group_6__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__Group_6__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPropertyAccess().getGreaterThanSignKeyword_6_2()); }
	'>'
	{ after(grammarAccess.getPropertyAccess().getGreaterThanSignKeyword_6_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ConstraintRule__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConstraintRule__Group__0__Impl
	rule__ConstraintRule__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConstraintRuleAccess().getConstraintRuleAction_0()); }
	()
	{ after(grammarAccess.getConstraintRuleAccess().getConstraintRuleAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConstraintRule__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConstraintRuleAccess().getGroup_1()); }
	(rule__ConstraintRule__Group_1__0)?
	{ after(grammarAccess.getConstraintRuleAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ConstraintRule__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConstraintRule__Group_1__0__Impl
	rule__ConstraintRule__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConstraintRuleAccess().getConstraintsAssignment_1_0()); }
	(rule__ConstraintRule__ConstraintsAssignment_1_0)
	{ after(grammarAccess.getConstraintRuleAccess().getConstraintsAssignment_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConstraintRule__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConstraintRuleAccess().getGroup_1_1()); }
	(rule__ConstraintRule__Group_1_1__0)*
	{ after(grammarAccess.getConstraintRuleAccess().getGroup_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ConstraintRule__Group_1_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConstraintRule__Group_1_1__0__Impl
	rule__ConstraintRule__Group_1_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group_1_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConstraintRuleAccess().getCommaKeyword_1_1_0()); }
	','
	{ after(grammarAccess.getConstraintRuleAccess().getCommaKeyword_1_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group_1_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConstraintRule__Group_1_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__Group_1_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConstraintRuleAccess().getConstraintsAssignment_1_1_1()); }
	(rule__ConstraintRule__ConstraintsAssignment_1_1_1)
	{ after(grammarAccess.getConstraintRuleAccess().getConstraintsAssignment_1_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumLiteralName__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumLiteralName__Group__0__Impl
	rule__EnumLiteralName__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralName__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumLiteralNameAccess().getIDTerminalRuleCall_0()); }
	RULE_ID
	{ after(grammarAccess.getEnumLiteralNameAccess().getIDTerminalRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralName__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumLiteralName__Group__1__Impl
	rule__EnumLiteralName__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralName__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumLiteralNameAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getEnumLiteralNameAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralName__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumLiteralName__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralName__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumLiteralNameAccess().getIDTerminalRuleCall_2()); }
	RULE_ID
	{ after(grammarAccess.getEnumLiteralNameAccess().getIDTerminalRuleCall_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__BooleanPropertyAttribute__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__BooleanPropertyAttribute__Group__0__Impl
	rule__BooleanPropertyAttribute__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttribute__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getBooleanPropertyAttributeAccess().getTypeAssignment_0()); }
	(rule__BooleanPropertyAttribute__TypeAssignment_0)
	{ after(grammarAccess.getBooleanPropertyAttributeAccess().getTypeAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttribute__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__BooleanPropertyAttribute__Group__1__Impl
	rule__BooleanPropertyAttribute__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttribute__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getBooleanPropertyAttributeAccess().getColonKeyword_1()); }
	':'
	{ after(grammarAccess.getBooleanPropertyAttributeAccess().getColonKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttribute__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__BooleanPropertyAttribute__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttribute__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getBooleanPropertyAttributeAccess().getAlternatives_2()); }
	(rule__BooleanPropertyAttribute__Alternatives_2)
	{ after(grammarAccess.getBooleanPropertyAttributeAccess().getAlternatives_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumLiteralPropertyAttribute__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumLiteralPropertyAttribute__Group__0__Impl
	rule__EnumLiteralPropertyAttribute__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralPropertyAttribute__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumLiteralPropertyAttributeAccess().getTypeAssignment_0()); }
	(rule__EnumLiteralPropertyAttribute__TypeAssignment_0)
	{ after(grammarAccess.getEnumLiteralPropertyAttributeAccess().getTypeAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralPropertyAttribute__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumLiteralPropertyAttribute__Group__1__Impl
	rule__EnumLiteralPropertyAttribute__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralPropertyAttribute__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumLiteralPropertyAttributeAccess().getColonKeyword_1()); }
	':'
	{ after(grammarAccess.getEnumLiteralPropertyAttributeAccess().getColonKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralPropertyAttribute__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumLiteralPropertyAttribute__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralPropertyAttribute__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumLiteralPropertyAttributeAccess().getValueAssignment_2()); }
	(rule__EnumLiteralPropertyAttribute__ValueAssignment_2)
	{ after(grammarAccess.getEnumLiteralPropertyAttributeAccess().getValueAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DictionaryPropertyType__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DictionaryPropertyType__Group__0__Impl
	rule__DictionaryPropertyType__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDictionaryPropertyTypeAccess().getDictionaryPropertyTypeAction_0()); }
	()
	{ after(grammarAccess.getDictionaryPropertyTypeAccess().getDictionaryPropertyTypeAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DictionaryPropertyType__Group__1__Impl
	rule__DictionaryPropertyType__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDictionaryPropertyTypeAccess().getDictionaryKeyword_1()); }
	'Dictionary'
	{ after(grammarAccess.getDictionaryPropertyTypeAccess().getDictionaryKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DictionaryPropertyType__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDictionaryPropertyTypeAccess().getGroup_2()); }
	(rule__DictionaryPropertyType__Group_2__0)?
	{ after(grammarAccess.getDictionaryPropertyTypeAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DictionaryPropertyType__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DictionaryPropertyType__Group_2__0__Impl
	rule__DictionaryPropertyType__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDictionaryPropertyTypeAccess().getLeftSquareBracketKeyword_2_0()); }
	'['
	{ after(grammarAccess.getDictionaryPropertyTypeAccess().getLeftSquareBracketKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DictionaryPropertyType__Group_2__1__Impl
	rule__DictionaryPropertyType__Group_2__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDictionaryPropertyTypeAccess().getKeyTypeAssignment_2_1()); }
	(rule__DictionaryPropertyType__KeyTypeAssignment_2_1)
	{ after(grammarAccess.getDictionaryPropertyTypeAccess().getKeyTypeAssignment_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DictionaryPropertyType__Group_2__2__Impl
	rule__DictionaryPropertyType__Group_2__3
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDictionaryPropertyTypeAccess().getCommaKeyword_2_2()); }
	','
	{ after(grammarAccess.getDictionaryPropertyTypeAccess().getCommaKeyword_2_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DictionaryPropertyType__Group_2__3__Impl
	rule__DictionaryPropertyType__Group_2__4
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDictionaryPropertyTypeAccess().getValueTypeAssignment_2_3()); }
	(rule__DictionaryPropertyType__ValueTypeAssignment_2_3)
	{ after(grammarAccess.getDictionaryPropertyTypeAccess().getValueTypeAssignment_2_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DictionaryPropertyType__Group_2__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__Group_2__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDictionaryPropertyTypeAccess().getRightSquareBracketKeyword_2_4()); }
	']'
	{ after(grammarAccess.getDictionaryPropertyTypeAccess().getRightSquareBracketKeyword_2_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Presence__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Presence__Group__0__Impl
	rule__Presence__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Presence__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPresenceAccess().getPresenceAction_0()); }
	()
	{ after(grammarAccess.getPresenceAccess().getPresenceAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Presence__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Presence__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Presence__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPresenceAccess().getAlternatives_1()); }
	(rule__Presence__Alternatives_1)
	{ after(grammarAccess.getPresenceAccess().getAlternatives_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Constraint__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Constraint__Group__0__Impl
	rule__Constraint__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Constraint__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConstraintAccess().getTypeAssignment_0()); }
	(rule__Constraint__TypeAssignment_0)
	{ after(grammarAccess.getConstraintAccess().getTypeAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Constraint__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Constraint__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Constraint__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConstraintAccess().getConstraintValuesAssignment_1()); }
	(rule__Constraint__ConstraintValuesAssignment_1)
	{ after(grammarAccess.getConstraintAccess().getConstraintValuesAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__CATEGORY__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group__0__Impl
	rule__CATEGORY__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_0()); }
	RULE_ID
	{ after(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getGroup_1()); }
	(rule__CATEGORY__Group_1__0)*
	{ after(grammarAccess.getCATEGORYAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__CATEGORY__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group_1__0__Impl
	rule__CATEGORY__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getSolidusKeyword_1_0()); }
	'/'
	{ after(grammarAccess.getCATEGORYAccess().getSolidusKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_1_1()); }
	RULE_ID
	{ after(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ModelReference__ImportedNamespaceAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getModelReferenceAccess().getImportedNamespaceQualifiedNameParserRuleCall_1_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getModelReferenceAccess().getImportedNamespaceQualifiedNameParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__VersionAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getModelReferenceAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
		RULE_VERSION
		{ after(grammarAccess.getModelReferenceAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__NamespaceAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getNamespaceQualifiedNameParserRuleCall_1_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getEntityAccess().getNamespaceQualifiedNameParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__VersionAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
		RULE_VERSION
		{ after(grammarAccess.getEntityAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__DisplaynameAssignment_4_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getDisplaynameSTRINGTerminalRuleCall_4_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEntityAccess().getDisplaynameSTRINGTerminalRuleCall_4_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__DescriptionAssignment_5_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getDescriptionSTRINGTerminalRuleCall_5_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEntityAccess().getDescriptionSTRINGTerminalRuleCall_5_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__CategoryAssignment_6_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getCategoryCATEGORYParserRuleCall_6_1_0()); }
		ruleCATEGORY
		{ after(grammarAccess.getEntityAccess().getCategoryCATEGORYParserRuleCall_6_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__ReferencesAssignment_7
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getReferencesModelReferenceParserRuleCall_7_0()); }
		ruleModelReference
		{ after(grammarAccess.getEntityAccess().getReferencesModelReferenceParserRuleCall_7_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__NameAssignment_9
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getNameIDTerminalRuleCall_9_0()); }
		RULE_ID
		{ after(grammarAccess.getEntityAccess().getNameIDTerminalRuleCall_9_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__SuperTypeAssignment_10_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getSuperTypeEntityCrossReference_10_1_0()); }
		(
			{ before(grammarAccess.getEntityAccess().getSuperTypeEntityQualifiedNameParserRuleCall_10_1_0_1()); }
			ruleQualifiedName
			{ after(grammarAccess.getEntityAccess().getSuperTypeEntityQualifiedNameParserRuleCall_10_1_0_1()); }
		)
		{ after(grammarAccess.getEntityAccess().getSuperTypeEntityCrossReference_10_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Entity__PropertiesAssignment_12
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAccess().getPropertiesPropertyParserRuleCall_12_0()); }
		ruleProperty
		{ after(grammarAccess.getEntityAccess().getPropertiesPropertyParserRuleCall_12_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__NamespaceAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getNamespaceQualifiedNameParserRuleCall_1_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getEnumAccess().getNamespaceQualifiedNameParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__VersionAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
		RULE_VERSION
		{ after(grammarAccess.getEnumAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__DisplaynameAssignment_4_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getDisplaynameSTRINGTerminalRuleCall_4_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEnumAccess().getDisplaynameSTRINGTerminalRuleCall_4_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__DescriptionAssignment_5_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getDescriptionSTRINGTerminalRuleCall_5_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEnumAccess().getDescriptionSTRINGTerminalRuleCall_5_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__CategoryAssignment_6_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getCategoryCATEGORYParserRuleCall_6_1_0()); }
		ruleCATEGORY
		{ after(grammarAccess.getEnumAccess().getCategoryCATEGORYParserRuleCall_6_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__ReferencesAssignment_7
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getReferencesModelReferenceParserRuleCall_7_0()); }
		ruleModelReference
		{ after(grammarAccess.getEnumAccess().getReferencesModelReferenceParserRuleCall_7_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__NameAssignment_9
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getNameIDTerminalRuleCall_9_0()); }
		RULE_ID
		{ after(grammarAccess.getEnumAccess().getNameIDTerminalRuleCall_9_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__EnumsAssignment_11_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getEnumsEnumLiteralParserRuleCall_11_0_0()); }
		ruleEnumLiteral
		{ after(grammarAccess.getEnumAccess().getEnumsEnumLiteralParserRuleCall_11_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Enum__EnumsAssignment_11_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAccess().getEnumsEnumLiteralParserRuleCall_11_1_1_0()); }
		ruleEnumLiteral
		{ after(grammarAccess.getEnumAccess().getEnumsEnumLiteralParserRuleCall_11_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteral__NameAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumLiteralAccess().getNameIDTerminalRuleCall_0_0()); }
		RULE_ID
		{ after(grammarAccess.getEnumLiteralAccess().getNameIDTerminalRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteral__DescriptionAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumLiteralAccess().getDescriptionSTRINGTerminalRuleCall_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEnumLiteralAccess().getDescriptionSTRINGTerminalRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__PresenceAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAccess().getPresencePresenceParserRuleCall_0_0()); }
		rulePresence
		{ after(grammarAccess.getPropertyAccess().getPresencePresenceParserRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__MultiplicityAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAccess().getMultiplicityMultipleKeyword_1_0()); }
		(
			{ before(grammarAccess.getPropertyAccess().getMultiplicityMultipleKeyword_1_0()); }
			'multiple'
			{ after(grammarAccess.getPropertyAccess().getMultiplicityMultipleKeyword_1_0()); }
		)
		{ after(grammarAccess.getPropertyAccess().getMultiplicityMultipleKeyword_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__NameAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAccess().getNameIDTerminalRuleCall_2_0()); }
		RULE_ID
		{ after(grammarAccess.getPropertyAccess().getNameIDTerminalRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__TypeAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAccess().getTypePropertyTypeParserRuleCall_4_0()); }
		rulePropertyType
		{ after(grammarAccess.getPropertyAccess().getTypePropertyTypeParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__PropertyAttributesAssignment_5_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAccess().getPropertyAttributesPropertyAttributeParserRuleCall_5_2_0()); }
		rulePropertyAttribute
		{ after(grammarAccess.getPropertyAccess().getPropertyAttributesPropertyAttributeParserRuleCall_5_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__PropertyAttributesAssignment_5_3_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAccess().getPropertyAttributesPropertyAttributeParserRuleCall_5_3_1_0()); }
		rulePropertyAttribute
		{ after(grammarAccess.getPropertyAccess().getPropertyAttributesPropertyAttributeParserRuleCall_5_3_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__ConstraintRuleAssignment_6_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAccess().getConstraintRuleConstraintRuleParserRuleCall_6_1_0()); }
		ruleConstraintRule
		{ after(grammarAccess.getPropertyAccess().getConstraintRuleConstraintRuleParserRuleCall_6_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Property__DescriptionAssignment_7
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPropertyAccess().getDescriptionSTRINGTerminalRuleCall_7_0()); }
		RULE_STRING
		{ after(grammarAccess.getPropertyAccess().getDescriptionSTRINGTerminalRuleCall_7_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__ConstraintsAssignment_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getConstraintRuleAccess().getConstraintsConstraintParserRuleCall_1_0_0()); }
		ruleConstraint
		{ after(grammarAccess.getConstraintRuleAccess().getConstraintsConstraintParserRuleCall_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConstraintRule__ConstraintsAssignment_1_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getConstraintRuleAccess().getConstraintsConstraintParserRuleCall_1_1_1_0()); }
		ruleConstraint
		{ after(grammarAccess.getConstraintRuleAccess().getConstraintsConstraintParserRuleCall_1_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttribute__TypeAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getBooleanPropertyAttributeAccess().getTypeBooleanPropertyAttributeTypeEnumRuleCall_0_0()); }
		ruleBooleanPropertyAttributeType
		{ after(grammarAccess.getBooleanPropertyAttributeAccess().getTypeBooleanPropertyAttributeTypeEnumRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__BooleanPropertyAttribute__ValueAssignment_2_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getBooleanPropertyAttributeAccess().getValueTrueKeyword_2_0_0()); }
		(
			{ before(grammarAccess.getBooleanPropertyAttributeAccess().getValueTrueKeyword_2_0_0()); }
			'true'
			{ after(grammarAccess.getBooleanPropertyAttributeAccess().getValueTrueKeyword_2_0_0()); }
		)
		{ after(grammarAccess.getBooleanPropertyAttributeAccess().getValueTrueKeyword_2_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralPropertyAttribute__TypeAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumLiteralPropertyAttributeAccess().getTypeEnumLiteralPropertyAttributeTypeEnumRuleCall_0_0()); }
		ruleEnumLiteralPropertyAttributeType
		{ after(grammarAccess.getEnumLiteralPropertyAttributeAccess().getTypeEnumLiteralPropertyAttributeTypeEnumRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumLiteralPropertyAttribute__ValueAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumLiteralPropertyAttributeAccess().getValueEnumLiteralCrossReference_2_0()); }
		(
			{ before(grammarAccess.getEnumLiteralPropertyAttributeAccess().getValueEnumLiteralEnumLiteralNameParserRuleCall_2_0_1()); }
			ruleEnumLiteralName
			{ after(grammarAccess.getEnumLiteralPropertyAttributeAccess().getValueEnumLiteralEnumLiteralNameParserRuleCall_2_0_1()); }
		)
		{ after(grammarAccess.getEnumLiteralPropertyAttributeAccess().getValueEnumLiteralCrossReference_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PrimitivePropertyType__TypeAssignment
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPrimitivePropertyTypeAccess().getTypePrimitiveTypeEnumRuleCall_0()); }
		rulePrimitiveType
		{ after(grammarAccess.getPrimitivePropertyTypeAccess().getTypePrimitiveTypeEnumRuleCall_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ObjectPropertyType__TypeAssignment
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getObjectPropertyTypeAccess().getTypeTypeCrossReference_0()); }
		(
			{ before(grammarAccess.getObjectPropertyTypeAccess().getTypeTypeQualifiedNameParserRuleCall_0_1()); }
			ruleQualifiedName
			{ after(grammarAccess.getObjectPropertyTypeAccess().getTypeTypeQualifiedNameParserRuleCall_0_1()); }
		)
		{ after(grammarAccess.getObjectPropertyTypeAccess().getTypeTypeCrossReference_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__KeyTypeAssignment_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDictionaryPropertyTypeAccess().getKeyTypePropertyTypeParserRuleCall_2_1_0()); }
		rulePropertyType
		{ after(grammarAccess.getDictionaryPropertyTypeAccess().getKeyTypePropertyTypeParserRuleCall_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DictionaryPropertyType__ValueTypeAssignment_2_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDictionaryPropertyTypeAccess().getValueTypePropertyTypeParserRuleCall_2_3_0()); }
		rulePropertyType
		{ after(grammarAccess.getDictionaryPropertyTypeAccess().getValueTypePropertyTypeParserRuleCall_2_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Presence__MandatoryAssignment_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPresenceAccess().getMandatoryMandatoryKeyword_1_0_0()); }
		(
			{ before(grammarAccess.getPresenceAccess().getMandatoryMandatoryKeyword_1_0_0()); }
			'mandatory'
			{ after(grammarAccess.getPresenceAccess().getMandatoryMandatoryKeyword_1_0_0()); }
		)
		{ after(grammarAccess.getPresenceAccess().getMandatoryMandatoryKeyword_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Constraint__TypeAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getConstraintAccess().getTypeConstraintIntervalTypeEnumRuleCall_0_0()); }
		ruleConstraintIntervalType
		{ after(grammarAccess.getConstraintAccess().getTypeConstraintIntervalTypeEnumRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Constraint__ConstraintValuesAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getConstraintAccess().getConstraintValuesIntervalTypeParserRuleCall_1_0()); }
		ruleIntervalType
		{ after(grammarAccess.getConstraintAccess().getConstraintValuesIntervalTypeParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

RULE_SIGNEDINT : '-' RULE_INT;

RULE_FLOAT : '-'? RULE_INT '.' RULE_INT;

fragment RULE_DATE : '0'..'9' '0'..'9' '0'..'9' '0'..'9' '-' '0'..'9' '0'..'9' '-' '0'..'9' '0'..'9';

fragment RULE_TIME : '0'..'9' '0'..'9' ':' '0'..'9' '0'..'9' ':' '0'..'9' '0'..'9' RULE_TIMEZONE?;

fragment RULE_TIMEZONE : ('Z'|('+'|'-') '0'..'9' '0'..'9' ':' '0'..'9' '0'..'9');

RULE_DATETIME : RULE_DATE 'T' RULE_TIME;

RULE_VERSION : ('0'..'9')* '.' ('0'..'9')* '.' ('0'..'9')* ('-' RULE_ID)?;

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

RULE_INT : ('0'..'9')+;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'|'\'' ('\\' .|~(('\\'|'\'')))* '\'');

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

RULE_WS : (' '|'\t'|'\r'|'\n')+;

RULE_ANY_OTHER : .;
